Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.exist.xquery
Class LocationStep

    java.lang.Object
      org.exist.xquery.AbstractExpression
          org.exist.xquery.Step
              org.exist.xquery.LocationStep

All Implemented Interfaces:
  Expression

public class LocationStep
extends Step

Processes all location path steps (like descendant::*, ancestor::XXX). The results of the first evaluation of the expression are cached for the lifetime of the object and only reloaded if the context sequence (as passed to the `eval(Sequence, Item)` method) has changed.

Author:
  wolf

Field Summary

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Constructor Summary
`LocationStep(XQueryContext context, int axis)`
`LocationStep(XQueryContext context, int axis, NodeTest test)`

Method Summary
`void` | `analyze(AnalyzeContextInfo contextInfo)` Statically analyze the expression and its subexpressions.
`Sequence` | `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`int` | `getDependencies()` Returns `Dependency.DEFAULT_DEPENDENCIES`.
`void` | `resetState()` Called to inform an expression that it should reset to its initial state.

Methods inherited from class org.exist.xquery.Step
`addPredicate, dump, getAxis, getCardinality, returnsType, setAxis, setPrimaryAxis, setTest, toString`

Methods inherited from class org.exist.xquery.AbstractExpression
`accept, eval, getASTNode, getContextDocSet, getContextId, getExpressionId, setASTNode, setContextDocSet`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### LocationStep

    public LocationStep(XQueryContext context,
                        int axis)

### LocationStep

    public LocationStep(XQueryContext context,
                        int axis,
                        NodeTest test)

Method Detail

### getDependencies

    public int getDependencies()

  Description copied from class: `AbstractExpression`
  Returns `Dependency.DEFAULT_DEPENDENCIES`.

  Specified by:
    `getDependencies` in interface `Expression`
  Overrides:
    `getDependencies` in class `AbstractExpression`
  See Also:
    `Expression.getDependencies()`

### analyze

    public void analyze(AnalyzeContextInfo contextInfo)
                 throws XPathException

  Description copied from interface: `Expression`
  Statically analyze the expression and its subexpressions. During the static analysis phase, the query engine can detect unknown variables and some type errors.

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `Step`
  Throws:
    `XPathException`

### eval

    public Sequence eval(Sequence contextSequence,
                         Item contextItem)
                  throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Specified by:
    `eval` in class `Step`
  Throws:
    `XPathException`

### resetState

    public void resetState()

  Description copied from interface: `Expression`
  Called to inform an expression that it should reset to its initial state. All cached data in the expression object should be dropped. For example, the document() function calls this method whenever the input document set has changed.

  Specified by:
    `resetState` in interface `Expression`
  Overrides:
    `resetState` in class `Step`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Wolfgang Meier. All rights reserved.